/***************************************************************************************************

  Main.cpp - test harness for DispLog.cpp

***************************************************************************************************/
#include <vcl.h>
#pragma hdrstop

#include "Main.h"

#pragma package(smart_init)
#pragma resource "*.dfm"

TFormMain *FormMain;
static int Count = 0;

//==================================================================================================
// Constructor
//==================================================================================================
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
  Log = new TDispLog();

  CheckBoxLogLine     ->Checked = Log->LogLine;
  CheckBoxDisplayLine ->Checked = Log->DisplayLine;
  CheckBoxAppendToLog ->Checked = Log->AppendToLog;
  CheckBoxDisplayTime ->Checked = Log->DisplayTime;
  CheckBoxDisplayMSecs->Checked = Log->DisplayMSecs;
  CheckBoxDisplayDate ->Checked = Log->DisplayDate;
  CheckBoxLogTime     ->Checked = Log->LogTime;
  CheckBoxLogMSecs    ->Checked = Log->LogMSecs;
  CheckBoxLogDate     ->Checked = Log->LogDate;
  CheckBoxKeepLogOpen ->Checked = Log->KeepLogOpen;

  EditDisplayDTPos->Text = IntToStr(Log->DisplayDTPos);
  EditLogDTPos    ->Text = IntToStr(Log->LogDTPos);
  EditMaxDispLines->Text = IntToStr(Log->MaxDispLines);

  EditLogFilename->Text = Log->LogFilename;
  EditSepString  ->Text = Log->SepString;
}



//==================================================================================================
// Destructor
//==================================================================================================
__fastcall TFormMain::~TFormMain(void)
{
  if(Log != NULL) {
    delete Log;
  }
}



//==================================================================================================
//==================================================================================================
// Check box event handlers
//==================================================================================================
//==================================================================================================



//==================================================================================================
// CheckBoxInitDisplayClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxInitDisplayClick(TObject *Sender)
{
  if(CheckBoxInitDisplay->Checked == True) {
    Log->InitDisplay(FormMain,PanelMemo->Top, PanelMemo->Left, PanelMemo->Height, PanelMemo->Width);
  } else {
    Log->RemoveDisplay();
  }
}



//==================================================================================================
// CheckBoxDisplayTimeClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxDisplayTimeClick(TObject *Sender)
{
  Log->DisplayTime = CheckBoxDisplayTime->Checked;

  if(Log->DisplayTime == false && Log->DisplayMSecs == true) {
    Log->DisplayMSecs             = false;
    CheckBoxDisplayMSecs->Checked = false;
  }
}



//==================================================================================================
// CheckBoxDisplayMSecsClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxDisplayMSecsClick(TObject *Sender)
{
  Log->DisplayMSecs = CheckBoxDisplayMSecs->Checked;

  if(Log->DisplayMSecs == true && Log->DisplayTime == false) {
    Log->DisplayTime             = true;
    CheckBoxDisplayTime->Checked = true;
  }
}



//==================================================================================================
// CheckBoxDisplayDateClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxDisplayDateClick(TObject *Sender)
{
  Log->DisplayDate = CheckBoxDisplayDate->Checked;
}



//==================================================================================================
// CheckBoxDisplayLineClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxDisplayLineClick(TObject *Sender)
{
  try {
    Log->DisplayLine = CheckBoxDisplayLine->Checked;
  } catch(Exception &E) {
    CheckBoxDisplayLine->Checked = false;

    throw;
  }
}



//==================================================================================================
// CheckBoxLogLineClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxLogLineClick(TObject *Sender)
{
  Log->LogLine = CheckBoxLogLine->Checked;
}



//==================================================================================================
// CheckBoxLogDateClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxLogDateClick(TObject *Sender)
{
  Log->LogDate = CheckBoxLogDate->Checked;
}



//==================================================================================================
// CheckBoxLogTimeClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxLogTimeClick(TObject *Sender)
{
  Log->LogTime = CheckBoxLogTime->Checked;

  if(Log->LogTime == false && Log->LogMSecs == true) {
    Log->LogMSecs             = false;
    CheckBoxLogMSecs->Checked = false;
  }
}



//==================================================================================================
// CheckBoxLogMSecsClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxLogMSecsClick(TObject *Sender)
{
  Log->LogMSecs = CheckBoxLogMSecs->Checked;

  if(Log->LogMSecs == true && Log->LogTime == false) {
    Log->LogTime             = true;
    CheckBoxLogTime->Checked = true;
  }
}



//==================================================================================================
// CheckBoxKeepLogOpen
//==================================================================================================
void __fastcall TFormMain::CheckBoxKeepLogOpenClick(TObject *Sender)
{
  try {
    Log->KeepLogOpen = CheckBoxKeepLogOpen->Checked;
  } catch(Exception &E) {
    CheckBoxKeepLogOpen->Checked = Log->KeepLogOpen;

    throw;
  }
}



//==================================================================================================
// CheckBoxAppendToLogClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxAppendToLogClick(TObject *Sender)
{
  bool Flag = Log->AppendToLog;

  try {
    Log->AppendToLog = CheckBoxAppendToLog->Checked;
  } catch(Exception &E) {
    CheckBoxAppendToLog->Checked = Flag;

    throw;
  }
}



//==================================================================================================
// CheckBoxDispHorizontalScrollBarClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxDisplayHorizontalScrollBarClick(TObject *Sender)
{
  Log->DispHorSBar = CheckBoxDisplayHorizontalScrollBar->Checked;
}



//==================================================================================================
// CheckBoxDisplayVerticalScrollBarClick
//==================================================================================================
void __fastcall TFormMain::CheckBoxDisplayVerticalScrollBarClick(TObject *Sender)
{
  Log->DispVerSBar = CheckBoxDisplayVerticalScrollBar->Checked;
}



//==================================================================================================
//==================================================================================================
// Edit event handlers
//==================================================================================================
//==================================================================================================


//==================================================================================================
// EditDisplayDTPosExit
//==================================================================================================
void __fastcall TFormMain::EditDisplayDTPosExit(TObject *Sender)
{
  int PrevValue = Log->DisplayDTPos;

  try {
    Log->DisplayDTPos = StrToInt(EditDisplayDTPos->Text);
  } catch(Exception &E) {
    EditDisplayDTPos->Text = IntToStr(PrevValue);

    throw;
  }
}


//==================================================================================================
// EditLogDTPosExit
//==================================================================================================
void __fastcall TFormMain::EditLogDTPosExit(TObject *Sender)
{
  int PrevValue = Log->LogDTPos;

  try {
    Log->LogDTPos = StrToInt(EditLogDTPos->Text);
  } catch(Exception &E) {
    EditLogDTPos->Text = IntToStr(PrevValue);

    throw;
  }
}


//==================================================================================================
// EditLogFilenameExit
//==================================================================================================
void __fastcall TFormMain::EditLogFilenameExit(TObject *Sender)
{
  Log->LogFilename = EditLogFilename->Text;
}


//==================================================================================================
// EditMaxDispLinesExit
//==================================================================================================
void __fastcall TFormMain::EditMaxDispLinesExit(TObject *Sender)
{
  Log->MaxDispLines = StrToInt(EditMaxDispLines->Text);
}


//==================================================================================================
// EditSepStringExit
//==================================================================================================
void __fastcall TFormMain::EditSepStringExit(TObject *Sender)
{
  Log->SepString = EditSepString->Text;
}



//==================================================================================================
//==================================================================================================
// Button event handlers
//==================================================================================================
//==================================================================================================



//==================================================================================================
// ButtonClearDisplayClick
//==================================================================================================
void __fastcall TFormMain::ButtonClearDisplayClick(TObject *Sender)
{
  Log->ClearDisplay();
  Count = 0;
}



//==================================================================================================
// ButtonAddLineClick - add a new line to the log
//==================================================================================================
void __fastcall TFormMain::ButtonAddLineClick(TObject *Sender)
{
  Log->AddLine("Test line number " + IntToStr(++Count) + ".");
}



//==================================================================================================
// ButtonAdd10LinesClick - add 10 new lines to the log
//==================================================================================================
void __fastcall TFormMain::ButtonAdd10LinesClick(TObject *Sender)
{
  for(int i=0; i<10; ++i) {
    Log->AddLine("Test line number " + IntToStr(++Count) + ".");
  }
}



//==================================================================================================
// ButtonAdd100LinesClick - add 100 new lines to the log
//==================================================================================================
void __fastcall TFormMain::ButtonAdd100LinesClick(TObject *Sender)
{
  for(int i=0; i<100; ++i) {
    Log->AddLine("Test line number " + IntToStr(++Count) + ".");
  }
}


